<template lang="pug">
loader(:loading="loaded" title="Loading documents...")
  div.q-pt-md.q-mb-lg
    q-breadcrumbs
      q-breadcrumbs-el(icon='home' to='/')
      q-breadcrumbs-el(:label='meeting.topic' icon='insert_invitation' :to='\'/\' + meeting[\'.key\']')
      q-breadcrumbs-el(icon="description")
        q-btn-dropdown(style="font-weight:normal;" type="a" label="Documents" no-caps flat)
          q-list
            q-item(:to="'/' + meeting['.key']")
              span Visualisation


      q-breadcrumbs-el(label='List' icon='description')
          
          
    .text-h4.q-pt-md Documents
  
  div.q-my-md.text-body1 Create and manage documents that you want to be distributed to break-out rooms during this class.
    div When distributed:
    ul
      li a copy of each document will be made per group for them to view and edit.
      li the link to this document will be sent via chat to each break out room.
      li copies are stored in your Google Drive for later access.
    
  q-banner.q-my-md.bg-deep-orange-8.text-white(v-if='botsInBO === 0')
    q-icon(size="md" name="warning")
    span.vertical-middle.text-body1 ZoomSensors need to be assigned to breakout rooms in the class before documents can be distributed!
  
  q-banner.q-my-md.bg-orange-10.text-white(v-else-if="botsInBO < meeting.noOfBreakoutRooms")
    q-icon(size="md" name="hourglass_empty")
    span.vertical-middle.text-body1 You can distribute a document now, but only {{botsInBO}} of {{meeting.noOfBreakoutRooms}} ZoomSensor(s) are in breakout rooms so far.
    
  q-banner.q-my-md.bg-positive.text-white(v-else)
    q-icon(size="md" name="done")
    span.vertical-middle.text-body1 You can distribute a document now, as all ZoomSensor(s) are in breakout rooms.
  
  .text-h5.q-pt-md Managed Documents

  div(v-if='meeting.gdocs && meeting.gdocs.documents')
    GDocTile(v-for='(doc, key) in meeting.gdocs.documents' :doc='doc' :docId='key' :meeting='meeting' :canDistribute='botsInBO > 0' :key='key')

  

  .row.justify-center.full-height.full-width.text-center.items-center(v-else style='color: #ccc; text-align:center;margin:2em;')
          div(style='margin-top:3em;')
            q-icon(name='insert_invitation' style='font-size:10em;')
            p.text-h6 Create a Document for this class.


  q-btn#gdoc-add-btn(type='a' v-on:click='addNewDocument' v-if='!this.$cookies.get("anonymous")' color='primary') Add New Document

</template>

<script>
import { db } from "../../db";
import GDocTile from "@/components/GDocTile.vue";
import Loader from "@/components/Loader.vue";
const meetings = db.ref("meetings");
const chatsRef = db.ref("data/chats");

export default {
  name: "ManageDocs",
  props: ["user"],
  data() {
    return {
      meetingId: this.$route.params.meetingId,
      meeting: { gdocs: {} },
      chats: {},

      selectedGoogleAccount: null,
      googleAccs: null,
      gToken: null,
      credential: null,
      authInstance: null,

      gDocId: null,
      findDocResult: null,

      newTitle: null,
      sections: [],
      loaded: false,
    };
  },
  created() {
    if (this.user) {
      const anonymous = this.$cookies.get("anonymous");

      if (!anonymous) {
        this.$rtdbBind(
          "meeting",
          meetings.child(this.user.uid).child(this.meetingId)
        ).then(() => {
          this.loaded = true;

          this.$rtdbBind("chats", chatsRef.child(this.meetingId));
          if (!this.meeting.gdocs) this.meeting.gdocs = {};
        });
      } else {
        this.meetingId = anonymous.meetingid;

        this.$rtdbBind(
          "meeting",
          meetings.child(anonymous.hostuid).child(this.meetingId)
        ).then(() => {
          this.loaded = true;

          this.$rtdbBind("chats", chatsRef.child(this.meetingId));
          if (!this.meeting.gdocs) this.meeting.gdocs = {};
        });
      }
    } else {
      this.$router.push("/");
    }
  },
  components: {
    GDocTile,
    Loader,
  },
  methods: {
    goToOverview: function () {
      this.$router.push("/" + this.meetingId);
    },
    addNewDocument: function () {
      this.$router.push("/adddoc/" + this.meetingId);
    },
  },
  computed: {
    botsInBO() {
      var count = 0;
      for (var i = 1; i <= this.meeting.noOfBreakoutRooms; i++) {
        if (
          this.chats[`ZoomSensor_${i}`] &&
          this.chats[`ZoomSensor_${i}`].isInBO
        )
          count++;
      }
      return count;
    },
  },
};
</script>